export declare type Mistake = Readonly<{
    contexts: ReadonlyArray<RegExp>;
    substring?: string;
    info?: string;
}>;
export declare type StringTransformer = (x: string) => string;
export declare function highlightWith(c: {
    mistakes: ReadonlyArray<Mistake>;
    verify: RegExp;
    identifiers: Readonly<{
        mistake: string;
        verified: string;
    }>;
    markWith: (identifier: string) => (info: string | null) => StringTransformer;
}): StringTransformer;
export declare function highlightMistakesWith(mistakes: ReadonlyArray<Mistake>, mark: (info: string | null) => StringTransformer): StringTransformer;
export declare function highlightVerifiedWith(pattern: RegExp, mark: StringTransformer): StringTransformer;
