const NO_INFO = null;
export function highlightWith(c) {
    return compose(highlightVerifiedWith(c.verify, c.markWith(c.identifiers.verified)(NO_INFO)), highlightMistakesWith(c.mistakes, c.markWith(c.identifiers.mistake)));
}
export function highlightMistakesWith(mistakes, mark) {
    function replacer(info, substring) {
        const transform = (substring === undefined
            ? mark(info)
            : (s) => s.split(substring).join(mark(info)(substring)));
        return (match, ...rest) => {
            const captured = rest.find(x => x !== undefined);
            return (typeof captured === "string"
                ? match.replace(captured, transform(captured))
                : transform(match));
        };
    }
    const transformers = mistakes.map(m => (text) => text.replace(join(m.contexts), replacer(m.info || null, m.substring)));
    return transformers.reduceRight(compose, x => x);
}
export function highlightVerifiedWith(pattern, mark) {
    return text => text.replace(pattern, mark);
}
function compose(f, g) {
    return x => f(g(x));
}
function join(patterns) {
    return new RegExp(patterns.map(p => p.source).join("|"), "g");
}
//# sourceMappingURL=index.js.map